#
## This file may be used under the terms of the GNU General Public
## License version 2.0 as published by the Free Software Foundation
## and appearing in the file LICENSE included in the packaging of
## this file. 
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
## See the NOTICE file distributed with this work for additional
## information regarding copyright ownership.


from threading import Thread
from Queue import PriorityQueue
from Queue import Empty
import time
import traceback
import sys

class Controller(Thread):
    
    def __init__(self, deskolo):
        Thread.__init__ (self)
        self.queue = PriorityQueue(0)
        self.flag = True
        self.deskolo = deskolo

    def addJob(self, epoch, jobFunction):
        self.queue.put((epoch, jobFunction))
    
    def run (self) :
        while self.flag:
            try:
                time.sleep(0.1)
                obj = self.queue.get_nowait()
                epochint = obj[0]
                target = obj[1]
                self.deskolo.log("Controller: launching %s - epoch:  %s" % (target, epochint))
                #sys.stdout.write(str(self.queue.qsize())+"\n")
                t = Thread(target=target, args=(epochint,))
                t.start()

            except Empty:
                pass

    def terminate(self):
        self.flag = False
        
        