#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
## This file may be used under the terms of the GNU General Public
## License version 2.0 as published by the Free Software Foundation
## and appearing in the file LICENSE included in the packaging of
## this file. 
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
## See the NOTICE file distributed with this work for additional
## information regarding copyright ownership.

from string import *
import os
import traceback
import sys
import re
from util import toolbox
from util import util
from datetime import datetime
import time

import deskolo

def dpmslog(argv):
    
    data = toolbox.openAnything("-")
    re_dpms = re.compile(r"\[\d\d:\d\d:\d\d\]\sPower level: (\d*)(.*)")
    
    for line in data:
        result = re_dpms.search(line)

        if result:
            
            level = result.group(1)
            
            date = line[1:9]
            now = datetime.now()
            
            epoch = int(time.mktime(time.strptime("%d-%d-%d " % (now.year, now.month, now.day) + date , '%Y-%m-%d %H:%M:%S')))
            
            try:
                deskolo.logQuantity("/var/lib/deskolo", "screen", "dpms", level, 1, epoch)
                
            except Exception, e:
                traceback.print_exc(file=sys.stdout)
                         
                
    
    return root

if __name__ == "__main__":
    if False:
        print "Usage:"
        print "\txlib-dpms | python " + sys.argv[0]
        sys.exit()

    dpmsinfo = dpmslog(sys.argv[1:])

