#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
## This file may be used under the terms of the GNU General Public
## License version 2.0 as published by the Free Software Foundation
## and appearing in the file LICENSE included in the packaging of
## this file. 
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
## See the NOTICE file distributed with this work for additional
## information regarding copyright ownership.

import gzip
import os
import re
import sys
import urllib
import tarfile
import shutil
import subprocess
from datetime import datetime

#http://effbot.org/zone/element-lib.htm#prettyprint

def indent(elem, level=0):
    i = "\n" + level*"  "
    if len(elem):
        if not elem.text or not elem.text.strip():
            elem.text = i + "  "
        if not elem.tail or not elem.tail.strip():
            elem.tail = i
        for elem in elem:
            indent(elem, level+1)
        if not elem.tail or not elem.tail.strip():
            elem.tail = i
    else:
        if level and (not elem.tail or not elem.tail.strip()):
            elem.tail = i



# file handling
def compress(file):
    #if config.get('global', 'gzip') == True:
    r_file = open(file, 'r')
    w_file = gzip.GzipFile(file + '.gz', 'w', 9)
    w_file.write(r_file.read())
    w_file.flush()
    w_file.close()
    r_file.close()
    os.unlink(file) #We don't need the file now

def read_as_string(file):
    # read the file
    f = open(file, "r")
    content = f.read()
    f.close()
    return content

def append_string(content, file, gzip=False):
    if os.path.exists(file):
        # ensure that we can write the file
        os.chmod(file, 0644)
    # write the string
    f = open(file, "w")
    f.write(content)
    f.close()
    if gzip:
        compress(file)

def set_string(content, file):
    if os.path.exists(file):
        # ensure that we can write the file
        os.chmod(file, 0644)
    f = open(file, "w")
    

def download_file(url, local_file):
    #remoteFileName = u"http://example.com/a.txt" # set the url here
    #localFileName = u"c:\\items.txt"
    log("Downloading %s into %s..." % (url, local_file))
    urllib.urlretrieve(url, local_file)


def untar(file_path, target_directory):
    tar = tarfile.open(file_path)
    tar.extractall(target_directory)
    tar.close()

def shell_exec(cmd, printcmd=False):
    if printcmd:
        log(cmd)
    proc = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    output = proc.communicate()[0]
    return output.strip()


        
def get_user_home(user):
    user_home = shell_exec("cat /etc/passwd | grep %s | awk -F \":\" ' { print $6 } '" % user)
    return user_home

def getFormattedDate():
    now = datetime.now()
    return datetime.strftime(now, "%Y-%m-%d")        


    
    