#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
## This file may be used under the terms of the GNU General Public
## License version 2.0 as published by the Free Software Foundation
## and appearing in the file LICENSE included in the packaging of
## this file. 
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
## See the NOTICE file distributed with this work for additional
## information regarding copyright ownership.

from string import *
import os
import traceback
import sys
import re
from util import toolbox
from util import util
import xml.etree.cElementTree as ET
from datetime import datetime
from dateutil.relativedelta import *
import time
import deskolo

def wattsuplog(argv):
    
    data = toolbox.openAnything("-")
        
    #http://effbot.org/zone/element.htm
    root = ET.Element("wattsup")
    
    re_wattsup = re.compile(r"\[\d\d:\d\d:\d\d\]\s[^,]*,\s[^,]*,\s[^,]*,\s[^,]*,\s[^,]*,\s[^,]*")
    
    
    for line in data:
        result = re_wattsup.search(line)
        measures = ["watts", "volts", "amps", "kwh", "duty-cycle", "power-cycle"]

        if result:
            #print "wattsup: " + line,
            #record = ET.SubElement(root, "record")
            
            values = line.split(",")
            
            watts = values[0].strip()
            date = watts[1:9]
            
            now = datetime.now()
            #13:52:22
            epoch = int(time.mktime(time.strptime("%d-%d-%d " % (now.year, now.month, now.day) + date , '%Y-%m-%d %H:%M:%S')))
            
            watts = watts[11:]
            
            values[0] = watts
            
            i = 0
            for value in values[0:]:
                value = value.strip()
                name = measures[i]
                try:
                    deskolo.logQuantity("/var/lib/deskolo", "wattsup", name, value, 1, epoch)
                    
                except Exception, e:
                    traceback.print_exc(file=sys.stdout)
                         
                i += 1
    
    return root

if __name__ == "__main__":
    if False:
        print "Usage:"
        print "\twattsup | python " + sys.argv[0]
        sys.exit()

    wattsupdata = wattsuplog(sys.argv[1:])

